program sbTest;

uses
  Go32, sbPlay, sbDetect, sbMixer, Dos, Crt;

{ = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = }
procedure DrawBar(channel: Byte);
type
  sPtr		= ^Shortint;
var
  value		: ShortInt;
  i		: Word;
begin
  if sbStatus[channel] = stStop then 
    value := 0 
  else begin
    value := tabVolume[sPtr(sbStart[channel]+(sbPos[channel] shr FixedPointShift))^, sbVolume[channel]];
  end;
  if (value < 0) then value := 0;
 
  for i := 1 to Abs(value) div 4 do Write('*');
  Writeln('                ');
end;

{ = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = }
var
  BaseIO	: Word;
  IRQ, DMA	: Byte;

  pDrumSound	: pSound;
  pPiewSound	: pSound;
  Ch		: Char;
  volume	: Byte;
  haveMixer	: Boolean;
  mastervol	: Byte;
begin
  ClrScr;  CursorOff;  AddExitProc(@CursorOn);
  WriteLn('sbPlay v1.1 - R.C. Mulder/BanderLabs');
  WriteLn('- ', plrCopyrightBlurb);
  if DetectSB(BaseIO, IRQ, DMA) then begin
    SampleRate := 22000;
    if InitSB(BaseIO, IRQ, DMA) then begin
      haveMixer := InitMixer(BaseIO);
      WriteLn('- Detected SB v', Hi(dspVersion),'.', Lo(dspVersion),' - ',SampleRate,' Hz',' - ',UpdateRate, ' ints/sec');
      WriteLn('  BaseIO: $', HexStr(BaseIO,3),'   IRQ: ', IRQ, '   DMA: ', DMA);

      GotoXY(60,2);  Write('Press Q to exit');

      pDrumSound := LoadRaw('drumloop.raw');
      pPiewSound := LoadRaw('piew.raw');

      volume := 32;
      GotoXY(3,5);  Write('Drum volume: ', volume:2);
      if (haveMixer) then begin
        mastervol := mixMaxVolume - 1;
        SetMasterVolume(mastervol, mastervol);
        WriteLn('  Master volume: ', mastervol);
      end else
        mastervol := 0;

      StartPlayer;

      PlaySound(1, pDrumSound, 11000, volume, stLoop);

      while (Ch <> 'q') do begin
        while Not KeyPressed do begin
          GotoXY(3,7);
          Write('IRQ count: ', irqCounter:8, '   ');
          Write('Drum pos: ', ((sbPos[1] - sbStart[1]) shr FixedPointShift):8);

           WriteLn;  WriteLn;
           DrawBar(1);
           DrawBar(2);
           DrawBar(3);
           DrawBar(4);
        end;

        Ch := ReadKey;
        case Upcase(Ch) of
          'Q': {};
          '2': PlaySound(2, pPiewSound, 16000, 32, stOnce);
          'W': PlaySound(2, pPiewSound, 16000, 63, stOnce);
          '3': PlaySound(3, pPiewSound,  8000, 32, stOnce);
          'E': PlaySound(3, pPiewSound,  8000, 63, stOnce);
          '4': PlaySound(4, pPiewSound,  4000, 32, stOnce);
          'R': PlaySound(4, pPiewSound,  4000, 63, stOnce);
          'A': sbStatus[1] := stStop;
          'S': sbStatus[1] := stLoop;
          '[': if (volume <>  0) then volume := volume - 1;
          ']': if (volume <> 63) then volume := volume + 1;
          'O': if (mastervol <> 0) then mastervol := mastervol - 1;
          'P': if (mastervol <> mixMaxVolume) then mastervol := mastervol + 1;
        end;
        sbVolume[1] := volume;
        GotoXY(3,5);  Write('Drum volume: ', volume:2);
        if (haveMixer) then begin
          WriteLn('  Master volume: ', mastervol:2);
          SetMasterVolume(mastervol, mastervol);
        end;
      end;

      StopPlayer;
      FreeSound(pPiewSound);
      FreeSound(pDrumSound);
      ShutdownSB;
    end else begin
      WriteLn('Couldn''t initialize SoundBlaster');
    end;
  end else begin
    WriteLn('Couldn''t find SoundBlaster (BLASTER environment var not set?)');
  end;
end.
